/**
 * An example of a filter stream (from JPL)
 */

import java.io.FileReader;
import java.io.FilterReader;
import java.io.IOException;
import java.io.Reader;

public class UppercaseConverter extends FilterReader {

    public UppercaseConverter(Reader in) {
        super(in);
    }

    public int read() throws IOException {
        int c = super.read();
        return (c == -1 ? c : Character.toUpperCase((char) c));
    }

    public int read(char[] buf, int offset, int count)
            throws IOException {
        int nread = super.read(buf, offset, count);
        int last = offset + nread;
        for (int i = offset; i < last; i++)
            buf[i] = Character.toUpperCase(buf[i]);
        return nread;
    }

    public static void main(String[] args)
            throws IOException {
        FileReader src = new FileReader(args[0]);
        UppercaseConverter f = new UppercaseConverter(src);

        int c;
        while ((c = f.read()) != -1)
            System.out.print((char) c);
        System.out.println();
    }
}
